function [optw] = ast_optw(gam,theta, param1, param2, u ,u2)

% d = 100000;
% 
% u = unifrnd(0,1,d,1);
% u2 = unifrnd(0,1,d,1);

% v = (u.^(-theta).*(u2.^(-theta/(1+theta))-1)+1).^(-1/theta);    %% Clayton
v = -1/theta*log(1 +  u2.*(1-exp(-theta))./(u2.*(exp(-theta.*u)-1) - exp(-theta.*u) ) );    %% Frank

%%%%%  r1
alpha = param1(1); 
nul = param1(2);  
nur = param1(3);  
mu = param1(4); 
sigma = param1(5); 

Kl =  gamma((nul+1)/2)/(gamma(nul/2)*sqrt(pi*nul));
Kr =  gamma((nur+1)/2)/(gamma(nur/2)*sqrt(pi*nur));
astar =  alpha*Kl/(alpha*Kl + (1-alpha)*Kr); 

r1 =  mu + sigma*(2*astar*tinv(min(u,alpha)/(2*alpha),nul) + 2*(1-astar)*tinv((max(u,alpha)+1-2*alpha)/(2*(1-alpha)),nur));

%%%%%  r2
alpha = param2(1); 
nul = param2(2);  
nur = param2(3);  
mu = param2(4); 
sigma = param2(5); 

Kl =  gamma((nul+1)/2)/(gamma(nul/2)*sqrt(pi*nul));
Kr =  gamma((nur+1)/2)/(gamma(nur/2)*sqrt(pi*nur));
astar =  alpha*Kl/(alpha*Kl + (1-alpha)*Kr); 

r2 =  mu + sigma*(2*astar*tinv(min(v,alpha)/(2*alpha),nul) + 2*(1-astar)*tinv((max(v,alpha)+1-2*alpha)/(2*(1-alpha)),nur));
%%%%%%%%

ws = [-100:200]'/100;
mws = 1-ws;
rp = ws*r1'/100 + mws*r2'/100;
up = (1+rp).^(1-gam)/(1-gam);
eup = mean(up,2);

[M,I] = max(eup);
optw = ws(I,1);

% plot(eup)


end
