function [sigmas,nlnL,scores,resfull,covarmat,ef,step1] = DCS_T_vol_model(param,y,extras)

%% Function to estimate a DCS T egarch volatility model.
%% input : param is the vector of initial values for the optimiser (note order)
%%         y is a univariate time series
%%         extras is a binary indicator (1 = yes) for whether additonal output should be calculated.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%settings and for the optimisation problem
    opt = optimset('TolX', 0.0001, 'Display', 'off', 'MaxIter', 5000, 'MaxFunEvals', 5000, 'HessUpdate', 'bfgs') ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

param(2) = log(param(2)/(.999-param(2)));

fst = @(p)DCS_T_vol_nll(p,y);
[resfull,val,ef] = fminsearch(fst,param,opt);                 %% conduct optimisation
% [resfull,val,ef] = fminunc(fst,param,opt); 
[nlnL,sigmas,scores,step1] = DCS_T_vol_nll(resfull,y);        %% Evaluate model at MLEs to get fitted states, scores and llf

resfull(2) = .999/(1+exp(-resfull(2)));

covarmat = eye(length(param));

if (extras == 1)
   covarmat = eye(length(param));                            %% To be updated with analytical matrix at a later date 
end
end